
#include <WS2812FX.h>
#include "ESP32_RTM_Driver.h"
#include "DualLarson.h"
#include "Rain.h"
#include <WiFi.h>
#include <WiFiClient.h>
#include <WebServer.h>
//#include <ESPmDNS.h>
#include <Update.h>

// Which pin on the Arduino is connected to the NeoPixels?
// On a Trinket or Gemma we suggest changing this to 1

#define LED_PIN 32                       // 0 = GPIO0, 2=GPIO2
#define LED_COUNT 17
#define DEFAULT_COLOR 0xFE821E
#define DEFAULT_BRIGHTNESS 200
#define DEFAULT_SPEED 10688
#define DEFAULT_MODE FX_MODE_STATIC

#define WIFI_SSID "*****"     // WiFi network
#define WIFI_PASSWORD "********" // WiFi network password

  IPAddress ip(192,168,0,117);
  IPAddress gateway(192,168,0,100);
  IPAddress subnet(255,255,255,0);

WebServer server(8080);
const char* serverIndex = "<form method='POST' action='/update' enctype='multipart/form-data'><input type='file' name='update'><input type='submit' value='Update'></form>";

unsigned long auto_last_change = 0;
String modes = "";
uint8_t myModes[] = {}; // *** optionally create a custom list of effect/mode numbers
boolean auto_cycle = false;
int brightness = 200;
int Mode = 0;

// When we setup the NeoPixel library, we tell it how many pixels, and which pin to use to send signals.
// Note that for older NeoPixel strips you might need to change the third parameter--see the strandtest
// example for more information on possible values.
WS2812FX ws2812fx = WS2812FX(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);

#define Threshold 40 /* Greater the value, more the sensitivity */

RTC_DATA_ATTR int bootCount = 0;
touch_pad_t touchPin;
int threshold = 40;
bool touch1detected = false;
bool touch2detected = false;
bool touch3detected = false;
bool touch4detected = false;
bool wifi_on = false;

void gotTouch1(){
 touch1detected = true;
}
void gotTouch2(){
 touch2detected = true;
}
void gotTouch3(){
 touch3detected = true;
}
void gotTouch4(){
 touch4detected = true;
}
/*
Method to print the reason by which ESP32
has been awaken from sleep
*/
void print_wakeup_reason(){
  esp_sleep_wakeup_cause_t wakeup_reason;

  wakeup_reason = esp_sleep_get_wakeup_cause();

  switch(wakeup_reason)
  {
    case ESP_SLEEP_WAKEUP_EXT0 : Serial.println("Wakeup caused by external signal using RTC_IO"); break;
    case ESP_SLEEP_WAKEUP_EXT1 : Serial.println("Wakeup caused by external signal using RTC_CNTL"); break;
    case ESP_SLEEP_WAKEUP_TIMER : Serial.println("Wakeup caused by timer"); break;
    case ESP_SLEEP_WAKEUP_TOUCHPAD : Serial.println("Wakeup caused by touchpad"); break;
    case ESP_SLEEP_WAKEUP_ULP : Serial.println("Wakeup caused by ULP program"); break;
    default : Serial.printf("Wakeup was not caused by deep sleep: %d\n",wakeup_reason); break;
  }
}

/*
Method to print the touchpad by which ESP32
has been awaken from sleep
*/
void print_wakeup_touchpad(){
  touchPin = esp_sleep_get_touchpad_wakeup_status();

  switch(touchPin)
  {
    case 0  : Serial.println("Touch detected on GPIO 4"); break;
    case 1  : Serial.println("Touch detected on GPIO 0"); break;
    case 2  : Serial.println("Touch detected on GPIO 2"); break;
    case 3  : Serial.println("Touch detected on GPIO 15"); break;
    case 4  : Serial.println("Touch detected on GPIO 13"); break;
    case 5  : Serial.println("Touch detected on GPIO 12"); break;
    case 6  : Serial.println("Touch detected on GPIO 14"); break;
    case 7  : Serial.println("Touch detected on GPIO 27"); break;
    case 8  : Serial.println("Touch detected on GPIO 33"); break;
    case 9  : Serial.println("Touch detected on GPIO 32"); break;
    default : Serial.println("Wakeup not by touchpad"); break;
  }
}



void setup(){
  Serial.begin(115200);
  delay(1000); //Take some time to open up the Serial Monitor
 
  modes.reserve(5000);
  modes_setup();

  Serial.println("Turn the lights on");
  Serial.println("WS2812FX setup");
  ws2812fx.init();
  ws2812fx.setMode(DEFAULT_MODE);
  ws2812fx.setColor(DEFAULT_COLOR);
  ws2812fx.setSpeed(DEFAULT_SPEED);
  ws2812fx.setBrightness(DEFAULT_BRIGHTNESS);
  
  rmt_tx_int(RMT_CHANNEL_0, ws2812fx.getPin()); // assign ws2812fx to RMT channel 0
  ws2812fx.setCustomShow(myCustomShow1);
  ws2812fx.start();


  
  //Increment boot number and print it every reboot
  ++bootCount;
  Serial.println("Boot number: " + String(bootCount));

  //Print the wakeup reason for ESP32 and touchpad too
  print_wakeup_reason();
  print_wakeup_touchpad();

  //Setup interrupt on Touch Pad 3 (GPIO15)
  touchAttachInterrupt(T7, gotTouch1, Threshold);
  touchAttachInterrupt(T6, gotTouch2, Threshold);
  touchAttachInterrupt(T5, gotTouch3, Threshold);
  touchAttachInterrupt(T4, gotTouch4, Threshold);
  //Configure Touchpad as wakeup source
  esp_sleep_enable_touchpad_wakeup();  
  
  //esp_deep_sleep_start();
  Serial.println("Bla Bla");
}

void loop(){
  unsigned long now = millis();
  ws2812fx.service();
  if(wifi_on){
    server.handleClient();
  }
  //touch1 onoff
  if(touch1detected){
    touch1detected = false;
    Serial.println("Touch 1 detected");
    delay(1000);
    if(touch4detected){
    touch4detected = false;
    Serial.println("Touch 4 detected");
    
    if(wifi_on){
      Serial.println("Wifi aus");
    wifi_on = false;
    WiFi.disconnect();
    WiFi.mode(WIFI_OFF);
    
    delay(500);
    ws2812fx.setSpeed(200);ws2812fx.setMode(DEFAULT_MODE); ws2812fx.setColor(0xFF0000);ws2812fx.setBrightness(50);
    ws2812fx.service();
    delay(1000);
    ws2812fx.setSpeed(DEFAULT_SPEED);ws2812fx.setMode(DEFAULT_MODE); ws2812fx.setColor(DEFAULT_COLOR);ws2812fx.setBrightness(brightness);
    }else{
    Serial.println("Wifi an");
    wifi_on = true;
    wifi_activ();
    ws2812fx.setSpeed(200);ws2812fx.setMode(FX_MODE_BREATH); ws2812fx.setColor(0x00FF00);ws2812fx.setBrightness(50);
    ws2812fx.service();
    //delay(2000); //Uncomment bouth lines to get back to default after 2 sec
    //ws2812fx.setSpeed(DEFAULT_SPEED);ws2812fx.setMode(DEFAULT_MODE); ws2812fx.setColor(DEFAULT_COLOR);ws2812fx.setBrightness(brightness);
    }
    
    touch4detected = false;
    Serial.println("Touch 4");
    touch1detected = false;
    } else {
    Serial.println("Going to sleep now");
    ws2812fx.setColor(0x000000);
    ws2812fx.setBrightness(0);
    ws2812fx.setMode(FX_MODE_STATIC);   // Black/off
    
    delay(2000);
    esp_deep_sleep_start();
    Serial.println("This will never be printed");
    }}
  // Heller
  if(touch2detected){
    touch2detected = false;
    Serial.println("Touch 2 detected");
    Serial.println("Helligkeit +5");
    if (brightness <250) {brightness = brightness+5;};
    ws2812fx.setBrightness(brightness);
    Serial.println(brightness);
    delay(200);
    touch2detected = false;
    Serial.println("Touch 2");
    }
  //Dunkler
  if(touch3detected){
    touch3detected = false;
    Serial.println("Touch 3 detected");
    Serial.println("Helligkeit -5");
    if (brightness >5) {brightness = brightness-5;};
    ws2812fx.setBrightness(brightness);
    Serial.println(brightness);
    delay(200);
    touch3detected = false;
    Serial.println("Touch 3");
    }
  //Wechsel
  if(touch4detected){
    touch4detected = false;
    Serial.println("Touch 4 detected");
    Serial.println("Mode Change");
    if (Mode<9) {Mode = Mode + 1;} else {Mode = 0;};

  switch(Mode)
  {
    case 0  : Serial.println("Default");ws2812fx.setSpeed(DEFAULT_SPEED);ws2812fx.setMode(DEFAULT_MODE); ws2812fx.setColor(DEFAULT_COLOR); break;
    case 1  : Serial.println("Warmweiss");ws2812fx.setSpeed(DEFAULT_SPEED); ws2812fx.setMode(DEFAULT_MODE); ws2812fx.setColor(0xFF5c10); break; 
    case 2  : Serial.println("orangerot");ws2812fx.setSpeed(DEFAULT_SPEED);ws2812fx.setMode(DEFAULT_MODE); ws2812fx.setColor(0xFF3c05); break;
    case 3  : Serial.println("Kaltweiss");ws2812fx.setSpeed(DEFAULT_SPEED);ws2812fx.setMode(DEFAULT_MODE); ws2812fx.setColor(0xFF8c8c); break;
    case 4  : Serial.println("Rainbow");ws2812fx.setSpeed(DEFAULT_SPEED);ws2812fx.setMode(11); break;
    case 5  : Serial.println("Rainbow Cycle");ws2812fx.setSpeed(DEFAULT_SPEED);ws2812fx.setMode(12); break;
    case 6  : Serial.println("Fire Flicker");ws2812fx.setSpeed(DEFAULT_SPEED);ws2812fx.setColor(0xc93c20);ws2812fx.setMode(48); break;
    case 7  : Serial.println("Fire Flicker soft");ws2812fx.setSpeed(DEFAULT_SPEED);ws2812fx.setColor(0xc93c20);ws2812fx.setMode(49); break;
    case 8  : Serial.println("Rain");{
                      uint8_t RainMode  = ws2812fx.setCustomMode(F("Rain"), rain);
                      uint32_t colors[] = {RED, ORANGE, YELLOW}; ws2812fx.setSegment(0, 0, LED_COUNT - 1, RainMode, colors, 9000, FADE_SLOW); break;  
    }
    case 9  : Serial.println("Dual Larson");  {
                      uint8_t dualLarsonMode  = ws2812fx.setCustomMode(F("Dual Larson"), dualLarson);
                      uint32_t colors[] = {RED, ORANGE, YELLOW}; ws2812fx.setSegment(0, 0, LED_COUNT - 1, dualLarsonMode, colors, 6000, FADE_SLOW); break;  
    }
    
    default : Serial.println("Nix");ws2812fx.setSpeed(DEFAULT_SPEED);ws2812fx.setMode(DEFAULT_MODE); ws2812fx.setColor(DEFAULT_COLOR); break;
  }
   
    delay(1000);
    touch4detected = false;
    Serial.println("Touch 4");
    }

    //delay(100);
    //Serial.println("Still waiting...");

    
}

void wifi_activ() {
  WiFi.mode(WIFI_STA);
  WiFi.config(ip, gateway, subnet);
  delay(500);
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);
  if (WiFi.waitForConnectResult() == WL_CONNECTED) {
    //MDNS.begin(host);
    server.on("/", HTTP_GET, []() {
      server.sendHeader("Connection", "close");
      server.send(200, "text/html", serverIndex);
    });
    server.on("/update", HTTP_POST, []() {
      server.sendHeader("Connection", "close");
      server.send(200, "text/plain", (Update.hasError()) ? "FAIL" : "OK");
      ESP.restart();
    }, []() {
      HTTPUpload& upload = server.upload();
      if (upload.status == UPLOAD_FILE_START) {
        Serial.setDebugOutput(true);
        Serial.printf("Update: %s\n", upload.filename.c_str());
        if (!Update.begin()) { //start with max available size
          Update.printError(Serial);
        }
      } else if (upload.status == UPLOAD_FILE_WRITE) {
        if (Update.write(upload.buf, upload.currentSize) != upload.currentSize) {
          Update.printError(Serial);
        }
      } else if (upload.status == UPLOAD_FILE_END) {
        if (Update.end(true)) { //true to set the size to the current progress
          Serial.printf("Update Success: %u\nRebooting...\n", upload.totalSize);
        } else {
          Update.printError(Serial);
        }
        Serial.setDebugOutput(false);
      }
    });
    server.begin();
    //MDNS.addService("http", "tcp", 80);

      Serial.print("\r\nPoint your browser to ");
      
  Serial.println(WiFi.localIP());
  } else {
    Serial.println("WiFi Failed");
  }
}

void modes_setup() {
  modes = "";
  uint8_t num_modes = sizeof(myModes) > 0 ? sizeof(myModes) : ws2812fx.getModeCount();
  for(uint8_t i=0; i < num_modes; i++) {
    uint8_t m = sizeof(myModes) > 0 ? myModes[i] : i;
    modes += "<li><a href='#' class='m' id='";
    modes += m;
    modes += "'>";
    modes += ws2812fx.getModeName(m);
    modes += "</a></li>";
  }
}

// Custom show functions which will use the RMT hardware to drive the LEDs.
// Need a separate function for each ws2812fx instance.
void myCustomShow1(void) {
  uint8_t *pixels = ws2812fx.getPixels();
  // numBytes is one more then the size of the ws2812fx's *pixels array.
  // the extra byte is used by the driver to insert the LED reset pulse at the end.
  uint16_t numBytes = ws2812fx.getNumBytes() + 1;
  rmt_write_sample(RMT_CHANNEL_0, pixels, numBytes, false); // channel 0
}